LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;
USE work.ARRAY_PKG.all;	-- ̃pbP[Ẃgwork.hŎw

-- TOP Level Hardware
ENTITY array_speaker_driver IS
	PORT(
			clk_60MHz	: in 		STD_LOGIC;	-- Clock signal from FT232H
			data_in		: in 		STD_LOGIC_VECTOR(N_BYTE*8-1 downto 0);
												--Input from FT232H
			WR			: buffer	STD_LOGIC; 	-- zXgɃf[^]̂ƂP
			TXE			: in		STD_LOGIC; 	-- Transmit Bufffer Enough 
												-- 0mFăobt@ɏ
			RD			: buffer	STD_LOGIC;	-- zXgf[^]̂ƂP
			RXF			: in		STD_LOGIC;	-- Receiver Buffer Full
												-- 0mFăobt@Ǐo
			OE			: buffer	STD_LOGIC;	-- Output Enable
												-- FIFÕf[^o͂1
			RESET_SW  	: in  		STD_LOGIC; 	-- Connect to tact switch1
			START_SW	: in  		STD_LOGIC; 	-- Connect to tact switch2
			drive		: buffer 	SIG_ARRAY;	-- Output to Loudspeaker Array
			drive_clk	: buffer 	STD_LOGIC; 	-- Clock for loudspeaker array
			LED			: out 		STD_LOGIC_VECTOR(7 downto 0)-- LED Indicator 
	     );
END array_speaker_driver;

ARCHITECTURE behavior OF array_speaker_driver IS
	signal out_data	: SIG_ARRAY;	-- ACXs[Jւ̏o
	signal ch_data 	: SIG_ARRAY; 	-- `lZN^̏o	
	signal FIFO_out	: STD_LOGIC_VECTOR(N_CH*N_BYTE*8-1 downto 0);
	-- ^C~OpMF
	signal d_clk 	: STD_LOGIC; 	-- driver clock 쓮o͂̊Op
	signal cnt_d	: STD_LOGIC_VECTOR(7 downto 0); -- d_clkpJE^
	signal d_clk_D 	: STD_LOGIC;	-- d_clk60MHzNbN1x点
	signal reset 	: STD_LOGIC;	-- VXeŜ̃ZbgM
    signal Ch_cnt	: STD_LOGIC_VECTOR(4 downto 0); --`l̔ԍw
	signal Ch_cnt_D	: STD_LOGIC_VECTOR(4 downto 0); --`l̔ԍw
	signal ch_n		: STD_LOGIC_VECTOR(4 downto 0); --`lw
	signal RD_busy	: STD_LOGIC;	-- Read Busy
	signal RD_busy_D: STD_LOGIC;
	signal OE_busy	: STD_LOGIC; 	-- Output Enable Busy
	signal RXF_in 	: STD_LOGIC;
	-- ̃X^[gȂǂɊ֘AMF
	signal START_D 	: STD_LOGIC := '1';		-- START_SW1NbNxM
	signal START 	: STD_LOGIC := '1'; 	-- X^[gԂ\
	signal RUN 		: STD_LOGIC := '0'; 	-- sԁiRUNj
	-- mFp̐M
	signal STATUS	: STD_LOGIC_VECTOR(7 downto 0);
	--CONSTANT ND 	: integer := 19;
	-- FIFOpM
	signal WrEn 	: STD_LOGIC;
	signal RdEn 	: STD_LOGIC;
	signal RdEn_D 	: STD_LOGIC;
	signal Empty 	: STD_LOGIC;
	signal Full 	: STD_LOGIC;
	signal AmEmpty 	: STD_LOGIC;
	signal AmFull  	: STD_LOGIC;
	signal FIFO_reset  : STD_LOGIC;
	signal RPReset 	   : STD_LOGIC;
	signal AmEmptyThresh : STD_LOGIC_VECTOR(10 downto 0); 
	signal AmFullThresh  : STD_LOGIC_VECTOR(13 downto 0); 
COMPONENT FIFO8to64
    port (
        Data: in  std_logic_vector(7 downto 0); 
        WrClock: in  std_logic; 
        RdClock: in  std_logic; 
        WrEn: in  std_logic; 
        RdEn: in  std_logic; 
        Reset: in  std_logic; 
        RPReset: in  std_logic; 
        AmEmptyThresh: in  std_logic_vector(10 downto 0); 
        AmFullThresh: in  std_logic_vector(13 downto 0); 
        Q: out  std_logic_vector(63 downto 0); 
        Empty: out  std_logic; 
        Full: out  std_logic; 
        AlmostEmpty: out  std_logic; 
        AlmostFull: out  std_logic);
end COMPONENT;
	
BEGIN
drive_clk	<= d_clk;	-- 60MHz𕪎čd_clkOpɏo
reset 	<= RESET_SW; 	-- VXeZbgMRESETpXCb`ɂ萶
Ch_n	<= CONV_std_logic_vector(N_CH,5); 	-- N_CH̒lCh_nɐݒ
AmEmptyThresh <= CONV_std_logic_vector(2048,11); 
AmFullThresh <= CONV_std_logic_vector(2048,14); 

FIFO:FIFO8to64
	PORT MAP(
			Data 		=> data_in,
			WrClock 	=> clk_60MHz,
			RdClock 	=> d_clk,
			WrEn 		=> WrEn,
			RdEn 		=> RdEn,
			Reset 		=> FIFO_reset,
			RPReset 	=> RPReset,
			AmEmptyThresh => AmEmptyThresh,
			AmFullThresh => AmFullThresh,
			Q 			=> FIFO_out,
			Empty 		=> Empty,
			Full 		=> Full,
			AlmostEmpty	=> AmEmpty,
			AlmostFull	=> AmFull
			);
			
WrEn <= RUN AND (NOT RXF) AND NOT(Full) ;	-- RUN=1RXF=0̂Ƃ1
	-- RXF=0 ̂ƂFIFOobt@ɓǂރf[^݂
RD <= NOT WrEn;
--RdEn <= RUN AND AmEmpty;
RdEn <= RUN AND AmFull;
--RPReset <= '0'; 		-- FIFO_DCRead Pointer̓ZbgȂ
RPReset <= NOT RESET_SW; 
FIFO_reset <= NOT RESET_SW;-- FIFO_DC̃ZbgM
			
-- FT23260MHzM𕪎d_clk𐶐
PROCESS(clk_60MHz,reset) --@60MHzdrive_clk
CONSTANT WIDTH : integer := 8;	-- '1'̕
CONSTANT ND : integer := 19;	--  
BEGIN
	IF(reset ='0')THEN 
		cnt_d  <= (others => '0'); 
		d_clk <='0';
	ELSIF(clk_60MHz'EVENT AND clk_60MHz='1')THEN
		IF(cnt_d < ND)THEN
			cnt_d <= cnt_d + 1;
			IF(cnt_d < WIDTH)THEN
				d_clk <= '1';
			ELSE
				d_clk <= '0';
			END IF;
		ELSE
			cnt_d  <= (others => '0');
		END IF;
	END IF;
END PROCESS;

PROCESS(d_clk,reset) 
BEGIN
IF(reset = '0')THEN
	out_data <= (others =>(others => '0')); 
	ELSIF(d_clk'EVENT AND d_clk='1')THEN
    for I in 0 to N_CH-1 loop
		out_data(I) <= FIFO_out((I+1)*N_BYTE*8-1 downto I*N_BYTE*8);
	end loop;
	END IF;
END PROCESS;

drive <= out_data;
			
-- NbNɓSTARTM𐶐

START <= '0' WHEN cnt_d = 0 AND RUN = '1' ELSE
         '1';

-- OXCb`œMRUN𐶐
PROCESS(clk_60MHz,reset)
BEGIN
	IF(reset='0')THEN
		RUN <= '0';
	ELSIF(clk_60MHz'EVENT AND clk_60MHz = '1')THEN
		IF(START_SW = '0')THEN
			RUN <= '1';
		END IF;
	END IF;
END PROCESS;

-- RD controlF FT232HFIFOo͂ւ̐MRD𐶐
--RD <= NOT (RUN AND (NOT RXF));
	
OE <=  	NOT RUN; 	-- FT232H̏o͋M
WR <= '1';			-- FT232HւWRCƂ肠1
LED <= NOT STATUS;	-- LEDLowœ_̂Ŕ]

-- STATUS@LED\p̐M
PROCESS(clk_60MHz,reset)
CONSTANT K : integer := 0;
BEGIN
	IF(reset ='0')THEN
		STATUS <= (others =>'0');
		ELSIF(clk_60MHz'EVENT AND clk_60MHz = '1')THEN
			-- \svȐM̓RgAEg
			STATUS(7) <= drive(K)(7); STATUS(6) <= drive(K)(6);
			STATUS(5) <= drive(K)(5); STATUS(4) <= drive(K)(4);
			STATUS(3) <= drive(K)(3); STATUS(2) <= drive(K)(2);
			STATUS(1) <= drive(K)(1); STATUS(0) <= drive(K)(0);	
			--STATUS <= data_in;
	END IF;  
END PROCESS;

END behavior;