LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_textio.all;
LIBRARY STD;
USE std.textio.all;			-- eLXgt@Co͗p
USE work.ARRAY_PKG.all;		-- pbP[W

-- V~[Vł́CeXgx`gbvxƂȂ
ENTITY testbench IS	-- eXgx`̃GeBeB͊Oւ̓o͂
END testbench;		-- PORT錾

-- eXgx`̃A[LeN`LqEEE
ARCHITECTURE sim OF testbench IS
	-- eXgpsignal錾
	constant	CYCLE		: TIME		:= 16.67 ns;	-- 60MHzNbN̎ 
	signal 		RESET_SW  	: STD_LOGIC	:= '1';			-- ZbgXCb`   
	signal     	START_SW   	: STD_LOGIC	:= '1';			-- X^[gXCb`
	signal 		clk60MHz	: STD_LOGIC	:= '1'; 		-- from FT232H
	signal 		data       	: STD_LOGIC_VECTOR(N_BYTE*8 - 1 downto 0);
												-- USBC^tF[X̐M
	signal 		data_n 		: STD_LOGIC_VECTOR(7 downto 0);
	signal 		data_cnt	: STD_LOGIC_VECTOR(7 downto 0);
	signal		drive_clk 	: STD_LOGIC;
	signal		drive		: SIG_ARRAY;
	signal		WR			: STD_LOGIC;		-- WR=0Ńobt@ɏ
	signal		TXE			: STD_LOGIC :='1';	-- TXE=0mFăobt@ɏ 
	signal		RD			: STD_LOGIC;		-- RD=0Ńobt@ǂݏo\ɂ
	signal		RXF			: STD_LOGIC;		-- RXF=0mFĂRD=0ɂ
	signal		OE			: STD_LOGIC :='0';	-- OE=0Ńobt@o̓[h
	signal 		RD_clk 		: STD_LOGIC;
	signal 		LED			: STD_LOGIC_VECTOR(7 downto 0);
	
-- eXgn[hEFÃgbvxCOMPONENTɂ	     
COMPONENT array_speaker_driver IS
	PORT(
			clk_60MHz	: in 		STD_LOGIC;	-- Clock signal from FT232H
			data_in		: in 		STD_LOGIC_VECTOR(N_BYTE*8-1 downto 0);
												--Input from FT232H
			WR			: out		STD_LOGIC; 	-- zXgɃf[^]̂ƂP
			TXE			: in		STD_LOGIC; 	-- Transmit Bufffer Enough 
												-- 0mFăobt@ɏ
			RD			: out		STD_LOGIC;	-- zXgf[^]̂ƂP
			RXF			: in		STD_LOGIC;	-- Receiver Buffer Full
												-- 0mFăobt@Ǐo
			OE			: buffer	STD_LOGIC;	-- Output Enable
												-- FIFÕf[^o͂1
			RESET_SW  	: in  		STD_LOGIC; 	-- Connect to tact switch1
			START_SW	: in  		STD_LOGIC; 	-- Connect to tact switch2
			drive		: buffer 	SIG_ARRAY;	-- Output to Loudspeaker Array
			drive_clk	: buffer 	STD_LOGIC; 	-- Clock for loudspeaker array
												-- AC쓮M̊Op
			LED			: out 		STD_LOGIC_VECTOR(7 downto 0)	
												-- Status Indicator 
	     );
END component;
   
BEGIN
-- component instance@eXgn[hsignalڑ
driver : array_speaker_driver
	PORT MAP(
				clk_60MHz 	=> clk60MHz,
				data_in 	=> data,
				WR			=> WR,
				TXE			=> TXE,
				RD			=> RD,
				RXF			=> RXF,
				OE			=> OE,
				RESET_SW   	=> RESET_SW,
				START_SW 	=> START_SW,
				drive 		=> drive,
				drive_clk	=> drive_clk,
				--LED 		=> LED
				LED 		=> OPEN
			 ); 
-- CeXgpsignal𐶐Ă   
--Generate 60MHz clk 60MHzNbN𐶐
PROCESS	-- sensitivity list̂ŖɁCƌJԂ
BEGIN
	wait for CYCLE/2;		  -- CYCLE1/2҂ 
	clk60MHz <= not clk60MHz; -- ]
END PROCESS;
   
--RESETMiANeBu[j
PROCESS 
BEGIN
	wait for 10ns;		-- l110nsێĂC
	RESET_SW <= '0';	-- 0ɂ
	wait for 10ns;		-- 10ns̊0ێĂ
	RESET_SW <= '1';	-- Ă1ɖ߂
	wait;				-- waitƁCPROCESS1񂾂s
END PROCESS;			-- ܂Č́C 1ێ

--STARTMiANeBu[j@̐MœJn
PROCESS
BEGIN
	wait for 30ns;		-- RESETMςłSTARTM𐶐
	START_SW <= '0';	-- 0ɂ
	wait for 20ns;		-- 20ns̊0ێĂi20nsłȂĂOKj
	START_SW <= '1';	-- Ă1ɖ߂
	wait;				-- ̌́C 1ێ
END PROCESS;

-- RXF <= '0';
PROCESS(clk60MHz,RESET_SW)
BEGIN
IF(RESET_SW ='0')THEN
	RXF <= '0';
	data_cnt <= (others => '0');
	ELSIF(clk60MHz'EVENT AND clk60MHz = '1')THEN
		IF(data_cnt < 8)THEN
			RXF <= '0';
			data_cnt <= data_cnt +1;
		ELSE
			RXF <= '1';
		END IF;
END IF;
END PROCESS;
		
RD_clk <= NOT(RD) AND clk60MHz;

LED <= drive(0);

-- USBC^tF[X̃f[^𐶐

-- p^[PF
--RESET0ƂCRD_busy=1ɂȂC60MHzNbNɓ0`7܂ŕω
PROCESS(clk60MHz, RESET_SW)
BEGIN
	IF(RESET_SW = '0')THEN
		data <= (others => '0');
		ELSIF(clk60MHz'EVENT AND clk60MHz = '1')THEN
		IF(RD = '0')THEN
			IF(data < 15)THEN
				data <= data + 1;
			ELSE
				data <= (others => '0');
			END IF;
		END IF;
	END IF;			-- Ƃ肠CƂJԂƂɂĂ
END PROCESS;

-- p^[QF
-- drive_clk̗オ薈data𔽓]
--PROCESS(drive_clk, RESET_SW)
--BEGIN
--	IF(RESET_SW = '0')THEN
--		data <= (others => '0');
--		ELSIF(drive_clk'EVENT AND drive_clk = '1')THEN
--		data <= not data;
--	END IF;
--END PROCESS;

-- p^[RF
-- drive_clk̗オ薈dataP
--PROCESS(drive_clk, RESET_SW)
--BEGIN
--	IF(RESET_SW = '0')THEN
--		data <= (others => '0');
--		ELSIF(drive_clk'EVENT AND drive_clk = '1')THEN
--		data <= data + 1;
--	END IF;
--END PROCESS;

END sim;