LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;
USE work.ARRAY_PKG.all;	-- ̃pbP[Ẃgwork.hŎw

-- TOP Level Hardware  
ENTITY array_speaker_driver IS
	PORT(
			clk_60MHz	: in 		STD_LOGIC;	-- Clock signal from FT232H
			data_in		: in 		STD_LOGIC_VECTOR(N_BYTE*8-1 downto 0);
												--Input from FT232H
			WR			: out		STD_LOGIC; 	-- zXgɃf[^]̂ƂP
			TXE			: in		STD_LOGIC; 	-- Transmit Bufffer Enough 
												-- 0mFăobt@ɏ
			RD			: out		STD_LOGIC;	-- zXgf[^]̂ƂP
			RXF			: in		STD_LOGIC;	-- Receiver Buffer Full
												-- 0mFăobt@Ǐo
			OE			: out		STD_LOGIC;	-- Output Enable
												-- FIFÕf[^o͂1
			RESET_SW  	: in  		STD_LOGIC; 	-- Connect to tact switch1
			START_SW	: in  		STD_LOGIC; 	-- Connect to tact switch2
			drive		: out 		SIG_ARRAY;	-- Output to Loudspeaker Array
			drive_clk	: buffer 	STD_LOGIC; 	-- Clock for loudspeaker array
												-- AC쓮M̊Op
			LED			: out 		STD_LOGIC_VECTOR(7 downto 0);	
												-- Status Indicator 
			clk_out	 	: out 		STD_LOGIC
	     );
END array_speaker_driver;

ARCHITECTURE behavior OF array_speaker_driver IS
	signal out_data	: SIG_ARRAY;	-- ACXs[Jւ̏o
	signal ch_data 	: SIG_ARRAY; 	-- `lZN^̏o	
	-- ^C~OpMF
	signal d_clk 	: STD_LOGIC; 	-- driver clock 쓮o͂̊Op
	signal cnt_d	: STD_LOGIC_VECTOR(7 downto 0); -- d_clkpJE^
	signal d_clk_D 	: STD_LOGIC;	-- d_clk60MHzNbN1x点
	
	signal reset 	: STD_LOGIC;	-- VXeŜ̃ZbgM
    signal Ch_cnt	: STD_LOGIC_VECTOR(7 downto 0); --`l̔ԍw
	signal ch_n		: STD_LOGIC_VECTOR(7 downto 0); --`lw
	signal RD_busy	: STD_LOGIC := '0';		-- Read Busy
	signal OE_busy	: STD_LOGIC := '0'; 	-- Output Enable Busy
	--signal TXE_buf	: STD_LOGIC;
	signal Samp_cnt	: STD_LOGIC_VECTOR(15 downto 0) := "0000000000000000"; 
											-- TvJE^
	signal Samp_n	: STD_LOGIC_VECTOR(15 downto 0);	-- Tv̏
	
	-- ̃X^[gȂǂɊ֘AMF
	signal START_D 	: STD_LOGIC := '1';		-- START_SW1NbNxM
	signal START 	: STD_LOGIC := '1'; 	-- X^[gԂ\
	signal RUN 		: STD_LOGIC := '0'; 	-- sԁiRUNj
	signal STATUS	: STD_LOGIC_VECTOR(7 downto 0) := (others => '1');

COMPONENT OSC60MHz
 PORT(
    clk_out	:out	STD_LOGIC 	-- o
	);
END COMPONENT;
	
BEGIN
OSC:OSC60MHz
PORT MAP(clk_out => clk_out);
drive_clk	<= d_clk;	-- 60MHz𕪎čd_clkOpɏo
reset 	<= RESET_SW; 	-- VXeZbgMRESETpXCb`ɂ萶
Ch_n	<= CONV_std_logic_vector(N_CH,8); 	-- N_CH̒lCh_nɐݒ
Samp_n 	<= CONV_std_logic_vector(8192,16); 	-- TvSamp_nɐݒ
--TXE_buf <= TXE;
-- FT23260MHzM𕪎d_clk𐶐
PROCESS(clk_60MHz,reset) --@60MHz  drive_clk
CONSTANT WIDTH : integer := 8;	-- '1'̕
CONSTANT ND : integer := 19;	--  
BEGIN
	IF(reset ='0')THEN
		cnt_d  <= (others => '0');
		d_clk <='0';
	ELSIF(clk_60MHz'EVENT AND clk_60MHz='1')THEN
		IF(cnt_d < ND)THEN
			cnt_d <= cnt_d + 1;
			IF(cnt_d < WIDTH)THEN
				d_clk <= '1';
			ELSE
				d_clk <= '0';
			END IF;
		ELSE
			cnt_d  <= (others => '0');
		END IF;
	END IF;
END PROCESS;

-- `lZN^pJE^
PROCESS(clk_60MHz,reset) --Ch counter
BEGIN
	IF(reset='0')THEN
		Ch_cnt <= (others => '0');
	ELSIF(clk_60MHz'EVENT AND clk_60MHz='1') THEN
		IF(RUN ='1' AND cnt_d <N_CH)THEN
			IF(Ch_cnt = N_CH-1)THEN
				Ch_cnt <= (others => '0');
			ELSE
				Ch_cnt <= Ch_cnt + 1;
			END IF;
		END IF;
	END IF;
END PROCESS;

-- Tv񐔂̃JE^
PROCESS(clk_60MHz, reset,Ch_cnt)
BEGIN
	IF(reset='0')THEN
		Samp_cnt <= (others => '0');
	ELSIF(clk_60MHz'EVENT AND clk_60MHz='1' AND Ch_cnt =0)THEN
	    IF(Samp_cnt = 8192)THEN
		    Samp_cnt <= (others => '0');
	    ELSE
			Samp_cnt <= Samp_cnt + 1;
		END IF;
	END IF;
END PROCESS;

-- Channel Selector `lZN^
PROCESS(clk_60MHz, reset)
BEGIN
	IF(reset = '0')THEN
		ch_data <= (others => (others => '0'));
		ELSIF(clk_60MHz'EVENT AND clk_60MHz='1')THEN
			IF(RUN ='1' AND ch_cnt < N_CH AND cnt_d <N_CH)THEN
				ch_data(CONV_INTEGER(ch_cnt)) <= data_in;
		END IF;
	END IF;
END PROCESS;

-- Driver Output@o͗pŏIĩWX^
PROCESS(clk_60MHz, reset,cnt_d)
BEGIN
	IF(reset = '0')THEN
		out_data <= (others => (others => '0'));
		ELSIF(clk_60MHz'EVENT AND clk_60MHz='1' AND cnt_d = 0)THEN
			out_data <= ch_data;
	END IF;
END PROCESS;
drive <= out_data;
			
-- OXCb`NbNɓSTARTM𐶐
PROCESS(clk_60MHz, reset) 
BEGIN
	IF(reset='0')THEN
		START_D <= '1';			-- VXeZbgSTART_DPɃZbg
	ELSIF(clk_60MHz'EVENT AND clk_60MHz='1')THEN
		START_D <= START_SW;	-- START_DOSTART_SWM琶
	END IF;
END PROCESS;

-- d_clkSTARTM  g_hɂ蒷MNbÑpX𐶐
PROCESS(clk_60MHz, reset)
BEGIN
	IF(reset='0')THEN
		d_clk_D <= '0';		-- VXeZbgd_clk_D0ɃZbg
	ELSIF(clk_60MHz'EVENT AND clk_60MHz='1')THEN
		d_clk_D <= d_clk;	-- 1NbNxꂽM
	END IF;
END PROCESS;
START <= NOT(d_clk AND NOT(d_clk_D) AND RUN);

-- OXCb`œMRUN𐶐
PROCESS(clk_60MHz,reset)
BEGIN
	IF(reset='0')THEN
		RUN <= '0';
	ELSIF(clk_60MHz'EVENT AND clk_60MHz = '1')THEN
		IF(START_SW = '0')THEN
			RUN <= '1';
		END IF;
		IF(Samp_cnt = Samp_n)THEN
		    RUN <= '0';
	    END IF;
	END IF;
END PROCESS;

--State transition for RD_busy RDM邽߂̃Xe[g}V
PROCESS(clk_60MHz,reset)
BEGIN
	IF(reset='0')THEN
		RD_busy <= '0';
	ELSIF(clk_60MHz'EVENT AND clk_60MHz='1')THEN
		CASE RD_busy is
			WHEN '0' =>
				IF(START = '0' AND RXF = '0')THEN
					RD_busy <= '1';
				ELSE
					RD_busy <= '0';
				END IF;
			WHEN '1' => 
				IF(Ch_cnt = Ch_n-1)THEN
					RD_busy <= '0';
				ELSE
					RD_busy <= '1';
				END IF;
			WHEN OTHERS =>
					RD_busy <='0';
		END CASE;
	END IF;
END PROCESS;
-- RD controlF RD_busyRXFRDM𐶐
RD <=	'1' 	WHEN (RXF = '1' OR RD_busy ='0') ELSE
		'0' 	WHEN (RXF = '0' AND RD_busy = '1');
		-- RXF=0 ̂Ƃobt@ɓǂރf[^݂		
OE <=  	NOT RUN; 
LED <= NOT STATUS;
WR <= '0';
-- STATUS
PROCESS(clk_60MHz,reset)
BEGIN
	IF(reset ='0')THEN
		STATUS <= (others =>'0');
		ELSIF(clk_60MHz'EVENT AND clk_60MHz = '1')THEN
			STATUS(7) <= TXE;
			STATUS(0) <= RUN;
	END IF; 
END PROCESS;	
END behavior;